import "Turbine.UI";
import "Turbine.UI.Lotro";
 
 local instanceLatency = 300; -- Space for 300 instances before save-file needs resetting
 
-- find client language
 local locale = "en";
 if Turbine.Shell.IsCommand("hilfe") then
  locale = "de";
 elseif Turbine.Shell.IsCommand("aide") then
  locale = "fr";
 end

import "QueekusPlugins.InstanceTracker.Strings"

asRandomStrings ={};
asRandomStrings["en"]= { "World Instance/Raid Tracker", "Save", "Reset All", "Are you sure you want to clear all of your data?", "YES", "NO" };
asRandomStrings["de"] = { "Instanzquesten", "Speichern", "Neustart", "Sind Sie sicher, dass Sie alle Ihre Daten zu lschen?", "JA", "NEIN" };
asRandomStrings["fr"] = { "Les Instances/Raids du Monde", "Enregistrer", "R\195\169initialiser", "tes-vous sr que vous voulez effacer toutes vos donnes?", "OUI", "NON" };

local iInstanceTotal=table.maxn(instances["en"]); 
 
frmMain=Turbine.UI.Lotro.Window(); 
frmMain:SetSize(370,600); 
frmMain:SetPosition(0,500); 
frmMain:SetText(asRandomStrings[locale][1]); 
 
--frmMain.chkInstance = { };

-- Define a tree node class to put into the tree.
MyTreeNode = class( Turbine.UI.TreeNode );

function MyTreeNode:Constructor()
Turbine.UI.TreeNode.Constructor( self );

self:SetBackColor( Turbine.UI.Color( 1,1,1 ) );
self:SetSize( 100, 18 );
end

-- Create the tree view control.
treeView = Turbine.UI.TreeView();
treeView:SetParent( frmMain );
treeView:SetPosition( 10, 45 );
treeView:SetSize( 350, 520 );
treeView:SetBackColor( Turbine.UI.Color( 0.05, 0.05, 0.05 ) );
treeView:SetIndentationWidth( 30 );

-- Give the tree view a scroll bar.
scriptTextScrollBar = Turbine.UI.Lotro.ScrollBar();
scriptTextScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
scriptTextScrollBar:SetParent( frmMain );
scriptTextScrollBar:SetPosition( 350, 45 );
scriptTextScrollBar:SetSize( 10, 520 );

treeView:SetVerticalScrollBar( scriptTextScrollBar );

-- Confirmation Dialogue
	ConfDialogue = Turbine.UI.Label();
	ConfDialogue:SetParent( frmMain );
	ConfDialogue:SetSize( frmMain:GetWidth() - 35 , 100 );
	local dialogueHeight = ConfDialogue:GetHeight()
	ConfDialogue:SetPosition( 10, (frmMain:GetHeight() / 2) -  dialogueHeight / 2);
	ConfDialogue:SetBackColor( Turbine.UI.Color( 0.5, 0.5, 0.5 ) );
	ConfDialogue:SetText( "" );
	ConfDialogue:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	ConfDialogue:SetVisible(false);

	ConfirmText = Turbine.UI.Label();
	ConfirmText:SetParent( ConfDialogue );
	ConfirmText:SetSize( ConfDialogue:GetWidth() - 20 , ConfDialogue:GetHeight() - 60 );
	ConfirmText:SetPosition( 10, 10);
	ConfirmText:SetBackColor( Turbine.UI.Color( 0.5, 0.5, 0.5) );
	ConfirmText:SetForeColor( Turbine.UI.Color( 0, 0, 0) );
	ConfirmText:SetFont( Turbine.UI.Lotro.Font.Verdana16 );
	ConfirmText:SetText( asRandomStrings[locale][4] );
	ConfirmText:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	
	YesButton = Turbine.UI.Button();
	YesButton:SetPosition( 10, ConfDialogue:GetHeight() - 40 );
	YesButton:SetSize( (ConfDialogue:GetWidth() / 2) - 10, 30 );
	YesButton:SetParent( ConfDialogue );
	YesButton:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 1 ) );
	YesButton:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	YesButton:SetText( asRandomStrings[locale][5] );
	
	YesButton.MouseEnter = function( sender, args )
		YesButton:SetBackColor( Turbine.UI.Color( 0.1, 0.1, 5 ) );
	end
      
	YesButton.MouseLeave = function( sender, args )
		YesButton:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 1 ) );
	end

	NoButton = Turbine.UI.Button();
	NoButton:SetPosition( (ConfDialogue:GetWidth() / 2) + 10, ConfDialogue:GetHeight() - 40 );
	NoButton:SetSize( (ConfDialogue:GetWidth() / 2) - 20, 30 );
	NoButton:SetParent( ConfDialogue );
	NoButton:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 1 ) );
	NoButton:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	NoButton:SetText( asRandomStrings[locale][6] );
	
	NoButton.MouseEnter = function( sender, args )
		NoButton:SetBackColor( Turbine.UI.Color( 0.1, 0.1, 5 ) );
	end
      
	NoButton.MouseLeave = function( sender, args )
		NoButton:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 1 ) );
	end

-- Populate the test nodes.
local i;
local j;

rootNodes = treeView:GetNodes();
for i = 1, iInstanceTotal do
	local node = Turbine.UI.TreeNode();

	local lblTreeItem = Turbine.UI.Label();
	lblTreeItem:SetSize(360,20);
	lblTreeItem:SetMarkupEnabled(true);
	lblTreeItem:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	lblTreeItem:SetText(" " .. instances[locale][i]);
	lblTreeItem:SetFont( Turbine.UI.Lotro.Font.Verdana14 );
	lblTreeItem:SetParent(node);

	lblTreeItem.MouseEnter = function(sender,args)
		lblTreeItem:SetBackColor( Turbine.UI.Color( 0.55, 0.15, 0.15 ));
	end

	lblTreeItem.MouseLeave = function(sender,args)
		lblTreeItem:SetBackColor( Turbine.UI.Color( 0.05, 0.05, 0.05 ));          
	end        

	node:SetSize(380,20);
	node:SetExpanded(false);
	rootNodes:Add( node );

	local subNodes = node:GetChildNodes();
	local BossIndex = ("" .. i); 
	local iBossTotal=table.maxn(Bosses[BossIndex]); 
	for j = 1, iBossTotal do
		local node = Turbine.UI.TreeNode();

		local chkTreeItem = Turbine.UI.Lotro.CheckBox();
		chkTreeItem:SetSize(360,20);
		chkTreeItem:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		chkTreeItem:SetText(" " .. Bosses[BossIndex][j]);
		chkTreeItem:SetFont( Turbine.UI.Lotro.Font.Verdana16 );
		chkTreeItem:SetParent(node);

		chkTreeItem.CheckedChanged = function(sender,args)
			CheckTreeview()
		end

		chkTreeItem.MouseEnter = function(sender,args)
			chkTreeItem:SetBackColor( Turbine.UI.Color( 0.55, 0.15, 0.15 ));
		end

		chkTreeItem.MouseLeave = function(sender,args)
			chkTreeItem:SetBackColor( Turbine.UI.Color( 0.05, 0.05, 0.05 ));          
		end        

		node:SetSize(380,20);
		subNodes:Add( node );
	end
end

frmMain.cmdSave =Turbine.UI.Lotro.Button();
frmMain.cmdSave:SetText(asRandomStrings[locale][2]);
frmMain.cmdSave:SetPosition( 100, 570 );
frmMain.cmdSave:SetSize( 90, 20 );
frmMain.cmdSave:SetParent(frmMain);
 
frmMain.cmdReset =Turbine.UI.Lotro.Button();
frmMain.cmdReset:SetText(asRandomStrings[locale][3]);
frmMain.cmdReset:SetPosition( 200, 570 );
frmMain.cmdReset:SetSize( 90, 20 );
frmMain.cmdReset:SetParent(frmMain);
 
--Load the settings from the saved data
settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "InstanceTracker" );
--If no settings or not a table then use default values
if ( type( settings ) ~= "table" ) then
	settings = { };
	settings.positionX=0;
	settings.positionY=0;
	settings.instanceDone = {}; 
	for i = 1, instanceLatency do
		settings.instanceDone[i] = {}
	end
end

function CheckTreeview()

	local i;
	local j;

	RootNodes = treeView:GetNodes();
	for i = 1, iInstanceTotal do
		local ParentNode = RootNodes:Get(i);
		local ChildNodes = ParentNode:GetChildNodes();
        local MyParentControlList = ParentNode:GetControls();                              
		local MyLabel = MyParentControlList:Get(1);                              
		local BossIndex = ("" .. i); 
		local iBossTotal = table.maxn(Bosses[BossIndex]); 
		local sAllChecked;
		local numChecked = 0
		sAllChecked = "1";
		for j = 1, iBossTotal do
	                MyChildNode = ChildNodes:Get(j);                              
	                MyControlList = MyChildNode:GetControls();                              
	                ChildCheckbox = MyControlList:Get(1);                              
			if ChildCheckbox:IsChecked() == false then
				sAllChecked = "0"
			else
				numChecked = numChecked + 1
			end
		end
		if sAllChecked == "1" then
			MyLabel:SetForeColor( Turbine.UI.Color( 1,0,0 ));
		else
			MyLabel:SetForeColor( Turbine.UI.Color( 1,1,1 ));
		end
		if (numChecked > 0) then
			if (numChecked < iBossTotal) then
				MyLabel:SetText("".. instances[locale][i] .." - (" ..numChecked .."/" ..iBossTotal ..")")
				MyLabel:SetForeColor( Turbine.UI.Color( 0,0.75,0 ));
			else
				MyLabel:SetText("".. instances[locale][i])
			end
		else
			MyLabel:SetText("".. instances[locale][i])
		end
	end

end
--Set the form position from the saved settings
frmMain:SetPosition(settings.positionX, settings.positionY);
--Set the checkboxes from the saved data
for i=1,iInstanceTotal do
	
		RootNodes = treeView:GetNodes();
		local ParentNode = RootNodes:Get(i);
		local ChildNodes = ParentNode:GetChildNodes();
        local MyParentControlList = ParentNode:GetControls();                              
		local MyLabel = MyParentControlList:Get(1);                              
		local BossIndex = ("" .. i); 
		local iBossTotal = table.maxn(Bosses[BossIndex]); 
		local sAllChecked;
		sAllChecked = "1";
		for j = 1, iBossTotal do
			MyChildNode = ChildNodes:Get(j);                              
			MyControlList = MyChildNode:GetControls();                              
			ChildCheckbox = MyControlList:Get(1); 
			pcall( function()
				if settings.instanceDone[i][j] == 1 then
					ChildCheckbox:SetChecked(true)
				else
					ChildCheckbox:SetChecked(false)
				end
			end)
		end
end
CheckTreeview()
 
frmMain:SetVisible(true);
 
instanceTrackerCommand = Turbine.ShellCommand();
function instanceTrackerCommand:Execute( command, arguments )
	frmMain:SetVisible( not frmMain:IsVisible());
end
Turbine.Shell.AddCommand("InstTrack", InstanceTrackerCommand);

--********************************************************************************************
frmMain.cmdSave.Click = function( sender, args )
	X, Y = frmMain:GetPosition();
	settings.positionX=X;
	settings.positionY=Y;
	
	for i=1,iInstanceTotal do
		RootNodes = treeView:GetNodes();
		local ParentNode = RootNodes:Get(i);
		local ChildNodes = ParentNode:GetChildNodes();
        local MyParentControlList = ParentNode:GetControls();                              
		local MyLabel = MyParentControlList:Get(1);                              
		local BossIndex = ("" .. i); 
		local iBossTotal = table.maxn(Bosses[BossIndex]); 
		local sAllChecked;
		sAllChecked = "1";
		for j = 1, iBossTotal do
			MyChildNode = ChildNodes:Get(j);                              
			MyControlList = MyChildNode:GetControls();                              
			ChildCheckbox = MyControlList:Get(1); 
			if ChildCheckbox:IsChecked() == false then
				settings.instanceDone[i][j] = 0;
			else
				settings.instanceDone[i][j] = 1;
			end
		end
		
	end
	Turbine.PluginData.Save( Turbine.DataScope.Character, "InstanceTracker", settings );
end
 
--********************************************************************************************
frmMain.cmdReset.Click = function( sender, args )

	ConfDialogue:SetVisible(true);
	YesButton.Click = function( sender, args )
		ConfDialogue:SetVisible(false);
		for i=1,iInstanceTotal do
			RootNodes = treeView:GetNodes();
			local ParentNode = RootNodes:Get(i);
			local ChildNodes = ParentNode:GetChildNodes();
			local MyParentControlList = ParentNode:GetControls();                              
			local MyLabel = MyParentControlList:Get(1);                              
			local BossIndex = ("" .. i); 
			local iBossTotal = table.maxn(Bosses[BossIndex]); 
			local sAllChecked;
			sAllChecked = "1";
			for j = 1, iBossTotal do
				MyChildNode = ChildNodes:Get(j);                              
				MyControlList = MyChildNode:GetControls();                              
				ChildCheckbox = MyControlList:Get(1); 
				ChildCheckbox:SetChecked(false)
			end
		end
		CheckTreeview()
		frmMain.cmdSave.Click()
	end
	
	NoButton.Click = function( sender, args )
		ConfDialogue:SetVisible(false);
	end

end